package TemplateMethod;

public abstract class Template {
    public boolean isOn;

    public Template() {
	this.isOn = false;
    }

    abstract void welcome();
    abstract void turnOn();
    abstract void turnOff();
    
    public final void setup() {
	if (!isOn) {
	    welcome();
	    turnOn();
	}
    }

    public final void toggleSwitch() {
	if (this.isOn)
	    turnOff();
	else {
	    welcome();
	    turnOn();
	}
    }
}
